PROGRAM DueGruppi
   IMPLICIT NONE
   INCLUDE 'mpif.h'
   INTEGER :: Globale, LocComm, InterComm
   INTEGER :: stat, rc
   
   INTEGER :: colore, numproc, id, root, idinter
   INTEGER :: val, somma

    CALL MPI_Init(rc)
    CALL MPI_Comm_dup(MPI_COMM_WORLD, Globale, rc)
    CALL MPI_Comm_size(Globale, numproc, rc)
    CALL MPI_Comm_rank(Globale, id, rc)

    ! Si dividono i processi in 2 gruppi
    colore = MOD(id,2)

    CALL MPI_Comm_split(Globale, colore, id, LocComm, rc)

    ! Si genera l'inter comunicatore tra i 2 leader 
    IF ( colore == 0 ) THEN
       CALL MPI_Intercomm_create(LocComm, 0, Globale, 1, 01, InterComm, rc)
    ELSE
       CALL MPI_Intercomm_create(LocComm, 0, Globale, 0, 01, InterComm, rc)
    END IF

    ! Sommatoria  parziale di valori:
    !    per ogni gruppo si calcola la somma parziale 
    val = 1; somma = 0
    CALL MPI_Reduce(val,somma,1,MPI_INT,MPI_SUM,0,LocComm, rc)

    ! Ora si calcola la somma totale 
    CALL MPI_Comm_size(InterComm, numproc, rc)
    CALL MPI_Comm_rank(InterComm, idinter, rc)

    ! Ora il leader remoto invia i dati alla root 
    IF ( idinter == 0 ) THEN
       IF ( colore == 1) THEN
          CALL MPI_Send(somma,1,MPI_INT,0,101,InterComm, rc)
       ELSE
          CALL MPI_Recv(val,1,MPI_INT,0,101,InterComm,stat, rc)
          ! Somma globale 
          somma = somma + val
       END IF
    END IF

    CALL MPI_Barrier(Globale, rc)
    CALL MPI_Comm_free(InterComm, rc)
    CALL MPI_Comm_free(LocComm, rc)
    CALL MPI_Comm_free(Globale, rc)
    IF ( id == 0 ) THEN
       PRINT*,"La somma risulta = ", somma
    END IF

    CALL MPI_Finalize(rc)

    STOP
END PROGRAM DueGruppi
